<script lang="ts">
import Vue from 'vue';
import { MrktoForm } from '../common/index.vue';

export default Vue.extend({
  components: {
    MrktoForm,
  },
  props: {
    header: {
      type: String,
      required: false,
      default: '',
    },
    text: {
      type: String,
      required: false,
      default: '',
    },
    subHeader: {
      type: String,
      required: false,
      default: '',
    },
    headerConfig: {
      type: Object,
      required: false,
      default: () => {},
    },
    formId: {
      type: String,
      required: true,
    },
    requiredText: {
      type: String,
      required: false,
      default: '',
    },
    imageUrl: {
      type: String,
      required: false,
      default: '',
    },
    redirectUrl: {
      type: String,
      required: false,
      default: null,
    },
  },
  methods: {
    redirectOnSubmitSuccess() {
      if (this.redirectUrl) {
        window.location.replace(this.redirectUrl);
      }
    },
  },
});
</script>

<template>
  <div id="download-form">
    <div class="text-container">
      <img v-if="imageUrl" :src="imageUrl" :alt="header" />
      <SlpTypography
        class="text-container__header"
        tag="h5"
        variant="heading5-bold"
        >{{ header }}</SlpTypography
      >
      <SlpTypography tag="div" variant="body2">
        <div class="text" v-html="$md.render(text)" />
      </SlpTypography>
    </div>
    <div class="form-container">
      <MrktoForm
        :data="{
          formId,
          datalayer: 'resources',
          form_header: subHeader,
          header_config: headerConfig,
          required_text: requiredText,
        }"
        @submit-success="redirectOnSubmitSuccess"
      />
    </div>
  </div>
</template>

<style lang="scss" scoped>
#download-form {
  padding: $spacing-96 0;
  display: grid;
  grid-template-columns: 1fr 1fr;
  align-items: start;

  @media (max-width: $breakpoint-md) {
    grid-template-columns: 1fr;
    padding: $spacing-16 0;
  }

  @media (max-width: $breakpoint-md) {
    grid-template-columns: 1fr;
  }

  .text-container {
    background: $color-surface-50;
    border-radius: $spacing-8;
    padding: $spacing-32;
    max-width: 100%;

    @media (max-width: $breakpoint-lg) {
      margin-bottom: $spacing-48;
    }

    &__header {
      margin-bottom: $spacing-16;
    }

    img {
      max-width: 506px;

      @media (max-width: $breakpoint-lg) {
        max-width: 100%;
      }
    }

    &:deep {
      p {
        margin-bottom: 16px;
      }
    }
  }
  .form-container {
    @media (max-width: $breakpoint-lg) {
      margin-top: $spacing-48;
    }
    :deep(.form_column .form_container) {
      background: #f6f3fe;
      border-radius: 8px;
      .mktoButton {
        margin-top: 32px;
      }
      .mktoField {
        height: 45px;
      }
    }
  }
}
.text:deep(ul) {
  list-style: disc;
  padding-left: 40px;
  margin-bottom: 16px;
}
</style>
